#if !defined(AFX_BLKFXDIALOG_H__A388FEF9_47C8_4F2C_96E7_57DFA7E52E51__INCLUDED_)
#define AFX_BLKFXDIALOG_H__A388FEF9_47C8_4F2C_96E7_57DFA7E52E51__INCLUDED_
#include "StdAfx.h"
#include "Resource.h"
#include "params.h"
#include "DtSlider.h"
#include "Spectrogram.h"
#include "MIBlkFxCommon.h"
#include "SgramColBar.h"
#include "HorizTicksWnd.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// BlkFxDialog.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// BlkFxDialog dialog
class MIBlkFx;
class FxSetDialog;

class BlkFxDialog : public CDialog
{
// Construction
public:
	BlkFxDialog(MIBlkFxCommon* common_, CWnd* pParent = NULL);   // standard constructor
	~BlkFxDialog();
	
public:
	// windows messages that we handle
	enum { UPDATE_CONTROLS = 2000 };

	// Dialog Data
	//{{AFX_DATA(BlkFxDialog)
	enum { IDD = IDD_BLKFXDIALOG };
	//}}AFX_DATA


protected:

	void resizeSgram();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(BlkFxDialog)
	public:
	virtual BOOL DestroyWindow();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

protected:
	// Generated message map functions
	//{{AFX_MSG(BlkFxDialog)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnClose();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()

public:
	// common data
	Ref<MIBlkFxCommon> common;

	// font for text edits
	CFont font_arial, font_courier;

	// input/output spectrograms
	Spectrogram sgram[2];

	// frequency to pixel mapping for spectrograms & frequency controls
	PixelFreqMap pixel_freq_map;

	// colour mapping to use in spectrograms
	Spectrogram::ColMap col_map;

	// horizontal ticks window under sgrams
	HorizTicksWnd sgram_hticks[2];

	// colour bar beside spectrograms
	SgramColBar sgram_colbar;
};


//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_BLKFXDIALOG_H__A388FEF9_47C8_4F2C_96E7_57DFA7E52E51__INCLUDED_)
